// Copyright (c) 2013 Tom Steele, Dan Kottmann, FishNet Security
// See the file license.txt for copying permission

Template.vulnerabilityDescription.description = function() {
  var vulnerability = Vulnerabilities.findOne({"project_id": Session.get('projectId'), "_id": Session.get('vulnerabilityId')});
  if (!vulnerability) {
    return false;
  }
  return vulnerability.description;
};

Template.vulnerabilityDescription.events({
  'click #save-description': function(event, tpl) {
    var projectId = Session.get('projectId');
    var vulnerabilityId = Session.get('vulnerabilityId');
    var description = tpl.find('[name=description]').value;
    Meteor.call('setVulnerabilityDescription', projectId, vulnerabilityId, description, function(err, res) {
      if (err) {
        return Alerts.insert({"class": "alert-error", "strong": "Error", "message": err.reason});
      }
      return Alerts.insert({"class": "alert-success", "strong": "Success", "message": "Description saved"});
    })
  }
});