// Copyright (c) 2013 Tom Steele, Dan Kottmann, FishNet Security
// See the file license.txt for copying permission

Template.vulnerabilityEvidence.evidence = function() {
  var vulnerability = Vulnerabilities.findOne({"project_id": Session.get('projectId'), "_id": Session.get('vulnerabilityId')});
  if (!vulnerability) {
    return false;
  }
  return vulnerability.evidence;
};

Template.vulnerabilityEvidence.events({
  'click #save-evidence': function(event, tpl) {
    var projectId = Session.get('projectId');
    var vulnerabilityId = Session.get('vulnerabilityId');
    var evidence = tpl.find('[name=evidence]').value;
    Meteor.call('setVulnerabilityEvidence', projectId, vulnerabilityId, evidence, function(err, res) {
      if (err) {
        return Alerts.insert({"class": "alert-error", "strong": "Error", "message": err.reason});
      }
      return Alerts.insert({"class": "alert-success", "strong": "Success", "message": "Evidence saved"});
    })
  }
});