// Copyright (c) 2013 Tom Steele, Dan Kottmann, FishNet Security
// See the file license.txt for copying permission

Template.vulnerabilitySolution.solution = function() {
  var vulnerability = Vulnerabilities.findOne({"project_id": Session.get('projectId'), "_id": Session.get('vulnerabilityId')});
  if (!vulnerability) {
    return false;
  }
  return vulnerability.solution;
};

Template.vulnerabilitySolution.events({
  'click #save-solution': function(event, tpl) {
    var projectId = Session.get('projectId');
    var vulnerabilityId = Session.get('vulnerabilityId');
    var solution = tpl.find('[name=solution]').value;
    Meteor.call('setVulnerabilitySolution', projectId, vulnerabilityId, solution, function(err, res) {
      if (err) {
        return Alerts.insert({"class": "alert-error", "strong": "Error", "message": err.reason});
      }
      return Alerts.insert({"class": "alert-success", "strong": "Success", "message": "Solution saved"});
    })
  }
});